---
name: Bug report
about: Let us know about a bug!
title: ''
labels: ''
assignees: ''

---

<!-- Please reserve GitHub issues for bug reports and feature requests.

For questions, the best place to get answers is on our [discussion forum](https://discuss.hashicorp.com/c/vault), as they will get more visibility from experienced users than the issue tracker.

Please note: We take Vault's security and our users' trust very seriously. If you believe you have found a security issue in Vault, please responsibly disclose by contacting us at security@hashicorp.com. Our PGP key is available at [our security page](https://www.hashicorp.com/security/).

-->

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behavior:
1. Run `vault write ...`
2. Run `vault login....`
3. See error

**Expected behavior**
A clear and concise description of what you expected to happen.

**Environment:**
* Vault Server Version (retrieve with `vault status`):
* Vault CLI Version (retrieve with `vault version`):
* Server Operating System/Architecture:

Vault server configuration file(s):

```hcl
# Paste your Vault config here.
# Be sure to scrub any sensitive values
```

**Additional context**
Add any other context about the problem here.
