package kms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateKeyVersion invokes the kms.CreateKeyVersion API synchronously
func (client *Client) CreateKeyVersion(request *CreateKeyVersionRequest) (response *CreateKeyVersionResponse, err error) {
	response = CreateCreateKeyVersionResponse()
	err = client.DoAction(request, response)
	return
}

// CreateKeyVersionWithChan invokes the kms.CreateKeyVersion API asynchronously
func (client *Client) CreateKeyVersionWithChan(request *CreateKeyVersionRequest) (<-chan *CreateKeyVersionResponse, <-chan error) {
	responseChan := make(chan *CreateKeyVersionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateKeyVersion(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateKeyVersionWithCallback invokes the kms.CreateKeyVersion API asynchronously
func (client *Client) CreateKeyVersionWithCallback(request *CreateKeyVersionRequest, callback func(response *CreateKeyVersionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateKeyVersionResponse
		var err error
		defer close(result)
		response, err = client.CreateKeyVersion(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateKeyVersionRequest is the request struct for api CreateKeyVersion
type CreateKeyVersionRequest struct {
	*requests.RpcRequest
	KeyId string `position:"Query" name:"KeyId"`
}

// CreateKeyVersionResponse is the response struct for api CreateKeyVersion
type CreateKeyVersionResponse struct {
	*responses.BaseResponse
	RequestId  string     `json:"RequestId" xml:"RequestId"`
	KeyVersion KeyVersion `json:"KeyVersion" xml:"KeyVersion"`
}

// CreateCreateKeyVersionRequest creates a request to invoke CreateKeyVersion API
func CreateCreateKeyVersionRequest() (request *CreateKeyVersionRequest) {
	request = &CreateKeyVersionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Kms", "2016-01-20", "CreateKeyVersion", "kms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateKeyVersionResponse creates a response to parse from CreateKeyVersion response
func CreateCreateKeyVersionResponse() (response *CreateKeyVersionResponse) {
	response = &CreateKeyVersionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
