package kms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EnableKey invokes the kms.EnableKey API synchronously
func (client *Client) EnableKey(request *EnableKeyRequest) (response *EnableKeyResponse, err error) {
	response = CreateEnableKeyResponse()
	err = client.DoAction(request, response)
	return
}

// EnableKeyWithChan invokes the kms.EnableKey API asynchronously
func (client *Client) EnableKeyWithChan(request *EnableKeyRequest) (<-chan *EnableKeyResponse, <-chan error) {
	responseChan := make(chan *EnableKeyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EnableKey(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EnableKeyWithCallback invokes the kms.EnableKey API asynchronously
func (client *Client) EnableKeyWithCallback(request *EnableKeyRequest, callback func(response *EnableKeyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EnableKeyResponse
		var err error
		defer close(result)
		response, err = client.EnableKey(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EnableKeyRequest is the request struct for api EnableKey
type EnableKeyRequest struct {
	*requests.RpcRequest
	KeyId string `position:"Query" name:"KeyId"`
}

// EnableKeyResponse is the response struct for api EnableKey
type EnableKeyResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateEnableKeyRequest creates a request to invoke EnableKey API
func CreateEnableKeyRequest() (request *EnableKeyRequest) {
	request = &EnableKeyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Kms", "2016-01-20", "EnableKey", "kms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateEnableKeyResponse creates a response to parse from EnableKey response
func CreateEnableKeyResponse() (response *EnableKeyResponse) {
	response = &EnableKeyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
