package kms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateApplicationAccessPoint invokes the kms.UpdateApplicationAccessPoint API synchronously
func (client *Client) UpdateApplicationAccessPoint(request *UpdateApplicationAccessPointRequest) (response *UpdateApplicationAccessPointResponse, err error) {
	response = CreateUpdateApplicationAccessPointResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateApplicationAccessPointWithChan invokes the kms.UpdateApplicationAccessPoint API asynchronously
func (client *Client) UpdateApplicationAccessPointWithChan(request *UpdateApplicationAccessPointRequest) (<-chan *UpdateApplicationAccessPointResponse, <-chan error) {
	responseChan := make(chan *UpdateApplicationAccessPointResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateApplicationAccessPoint(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateApplicationAccessPointWithCallback invokes the kms.UpdateApplicationAccessPoint API asynchronously
func (client *Client) UpdateApplicationAccessPointWithCallback(request *UpdateApplicationAccessPointRequest, callback func(response *UpdateApplicationAccessPointResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateApplicationAccessPointResponse
		var err error
		defer close(result)
		response, err = client.UpdateApplicationAccessPoint(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateApplicationAccessPointRequest is the request struct for api UpdateApplicationAccessPoint
type UpdateApplicationAccessPointRequest struct {
	*requests.RpcRequest
	Policies    string `position:"Query" name:"Policies"`
	Description string `position:"Query" name:"Description"`
	Name        string `position:"Query" name:"Name"`
}

// UpdateApplicationAccessPointResponse is the response struct for api UpdateApplicationAccessPoint
type UpdateApplicationAccessPointResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateApplicationAccessPointRequest creates a request to invoke UpdateApplicationAccessPoint API
func CreateUpdateApplicationAccessPointRequest() (request *UpdateApplicationAccessPointRequest) {
	request = &UpdateApplicationAccessPointRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Kms", "2016-01-20", "UpdateApplicationAccessPoint", "kms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateApplicationAccessPointResponse creates a response to parse from UpdateApplicationAccessPoint response
func CreateUpdateApplicationAccessPointResponse() (response *UpdateApplicationAccessPointResponse) {
	response = &UpdateApplicationAccessPointResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
