package ram

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AttachPolicyToGroup invokes the ram.AttachPolicyToGroup API synchronously
func (client *Client) AttachPolicyToGroup(request *AttachPolicyToGroupRequest) (response *AttachPolicyToGroupResponse, err error) {
	response = CreateAttachPolicyToGroupResponse()
	err = client.DoAction(request, response)
	return
}

// AttachPolicyToGroupWithChan invokes the ram.AttachPolicyToGroup API asynchronously
func (client *Client) AttachPolicyToGroupWithChan(request *AttachPolicyToGroupRequest) (<-chan *AttachPolicyToGroupResponse, <-chan error) {
	responseChan := make(chan *AttachPolicyToGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AttachPolicyToGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AttachPolicyToGroupWithCallback invokes the ram.AttachPolicyToGroup API asynchronously
func (client *Client) AttachPolicyToGroupWithCallback(request *AttachPolicyToGroupRequest, callback func(response *AttachPolicyToGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AttachPolicyToGroupResponse
		var err error
		defer close(result)
		response, err = client.AttachPolicyToGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AttachPolicyToGroupRequest is the request struct for api AttachPolicyToGroup
type AttachPolicyToGroupRequest struct {
	*requests.RpcRequest
	PolicyType string `position:"Query" name:"PolicyType"`
	GroupName  string `position:"Query" name:"GroupName"`
	PolicyName string `position:"Query" name:"PolicyName"`
}

// AttachPolicyToGroupResponse is the response struct for api AttachPolicyToGroup
type AttachPolicyToGroupResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateAttachPolicyToGroupRequest creates a request to invoke AttachPolicyToGroup API
func CreateAttachPolicyToGroupRequest() (request *AttachPolicyToGroupRequest) {
	request = &AttachPolicyToGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ram", "2015-05-01", "AttachPolicyToGroup", "Ram", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAttachPolicyToGroupResponse creates a response to parse from AttachPolicyToGroup response
func CreateAttachPolicyToGroupResponse() (response *AttachPolicyToGroupResponse) {
	response = &AttachPolicyToGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
