package ram

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetPasswordPolicy invokes the ram.GetPasswordPolicy API synchronously
func (client *Client) GetPasswordPolicy(request *GetPasswordPolicyRequest) (response *GetPasswordPolicyResponse, err error) {
	response = CreateGetPasswordPolicyResponse()
	err = client.DoAction(request, response)
	return
}

// GetPasswordPolicyWithChan invokes the ram.GetPasswordPolicy API asynchronously
func (client *Client) GetPasswordPolicyWithChan(request *GetPasswordPolicyRequest) (<-chan *GetPasswordPolicyResponse, <-chan error) {
	responseChan := make(chan *GetPasswordPolicyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetPasswordPolicy(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetPasswordPolicyWithCallback invokes the ram.GetPasswordPolicy API asynchronously
func (client *Client) GetPasswordPolicyWithCallback(request *GetPasswordPolicyRequest, callback func(response *GetPasswordPolicyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetPasswordPolicyResponse
		var err error
		defer close(result)
		response, err = client.GetPasswordPolicy(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetPasswordPolicyRequest is the request struct for api GetPasswordPolicy
type GetPasswordPolicyRequest struct {
	*requests.RpcRequest
}

// GetPasswordPolicyResponse is the response struct for api GetPasswordPolicy
type GetPasswordPolicyResponse struct {
	*responses.BaseResponse
	RequestId      string         `json:"RequestId" xml:"RequestId"`
	PasswordPolicy PasswordPolicy `json:"PasswordPolicy" xml:"PasswordPolicy"`
}

// CreateGetPasswordPolicyRequest creates a request to invoke GetPasswordPolicy API
func CreateGetPasswordPolicyRequest() (request *GetPasswordPolicyRequest) {
	request = &GetPasswordPolicyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ram", "2015-05-01", "GetPasswordPolicy", "Ram", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetPasswordPolicyResponse creates a response to parse from GetPasswordPolicy response
func CreateGetPasswordPolicyResponse() (response *GetPasswordPolicyResponse) {
	response = &GetPasswordPolicyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
