# v1.53.1 (2024-03-29)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.53.0 (2024-03-18)

* **Feature**: Fix two issues with response root node names.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.52.1 (2024-03-15)

* **Documentation**: Documentation updates for Amazon S3.

# v1.52.0 (2024-03-13)

* **Feature**: This release makes the default option for S3 on Outposts request signing to use the SigV4A algorithm when using AWS Common Runtime (CRT).

# v1.51.4 (2024-03-07)

* **Bug Fix**: Remove dependency on go-cmp.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.51.3 (2024-03-05)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.51.2 (2024-03-04)

* **Bug Fix**: Update internal/presigned-url dependency for corrected API name.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.51.1 (2024-02-23)

* **Bug Fix**: Move all common, SDK-side middleware stack ops into the service client module to prevent cross-module compatibility issues in the future.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.51.0 (2024-02-22)

* **Feature**: Add middleware stack snapshot tests.

# v1.50.3 (2024-02-21)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.50.2 (2024-02-20)

* **Bug Fix**: When sourcing values for a service's `EndpointParameters`, the lack of a configured region (i.e. `options.Region == ""`) will now translate to a `nil` value for `EndpointParameters.Region` instead of a pointer to the empty string `""`. This will result in a much more explicit error when calling an operation instead of an obscure hostname lookup failure.

# v1.50.1 (2024-02-19)

* **Bug Fix**: Prevent potential panic caused by invalid comparison of credentials.

# v1.50.0 (2024-02-16)

* **Feature**: Add new ClientOptions field to waiter config which allows you to extend the config for operation calls made by waiters.

# v1.49.0 (2024-02-13)

* **Feature**: Bump minimum Go version to 1.20 per our language support policy.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.48.1 (2024-01-24)

* No change notes available for this release.

# v1.48.0 (2024-01-05)

* **Feature**: Support smithy sigv4a trait for codegen.

# v1.47.8 (2024-01-04)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.47.7 (2023-12-20)

* No change notes available for this release.

# v1.47.6 (2023-12-18)

* No change notes available for this release.

# v1.47.5 (2023-12-08)

* **Bug Fix**: Add non-vhostable buckets to request path when using legacy V1 endpoint resolver.
* **Bug Fix**: Improve uniqueness of default S3Express sesssion credentials cache keying to prevent collision in multi-credential scenarios.
* **Bug Fix**: Reinstate presence of default Retryer in functional options, but still respect max attempts set therein.

# v1.47.4 (2023-12-07)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.47.3 (2023-12-06)

* **Bug Fix**: Restore pre-refactor auth behavior where all operations could technically be performed anonymously.

# v1.47.2 (2023-12-01)

* **Bug Fix**: Correct wrapping of errors in authentication workflow.
* **Bug Fix**: Correctly recognize cache-wrapped instances of AnonymousCredentials at client construction.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.47.1 (2023-11-30)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.47.0 (2023-11-29)

* **Feature**: Expose Options() accessor on service clients.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.46.0 (2023-11-28.2)

* **Feature**: Add S3Express support.
* **Feature**: Adds support for S3 Express One Zone.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.45.1 (2023-11-28)

* **Bug Fix**: Respect setting RetryMaxAttempts in functional options at client construction.

# v1.45.0 (2023-11-27)

* **Feature**: Adding new params - Key and Prefix, to S3 API operations for supporting S3 Access Grants. Note - These updates will not change any of the existing S3 API functionality.

# v1.44.0 (2023-11-21)

* **Feature**: Add support for automatic date based partitioning in S3 Server Access Logs.
* **Bug Fix**: Don't send MaxKeys/MaxUploads=0 when unspecified in ListObjectVersions and ListMultipartUploads paginators.

# v1.43.1 (2023-11-20)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.43.0 (2023-11-17)

* **Feature**: **BREAKING CHANGE** Correct nullability of a large number of S3 structure fields. See https://github.com/aws/aws-sdk-go-v2/issues/2162.
* **Feature**: Removes all default 0 values for numbers and false values for booleans

# v1.42.2 (2023-11-15)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.42.1 (2023-11-09)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.42.0 (2023-11-01)

* **Feature**: Adds support for configured endpoints via environment variables and the AWS shared configuration file.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.41.0 (2023-10-31)

* **Feature**: **BREAKING CHANGE**: Bump minimum go version to 1.19 per the revised [go version support policy](https://aws.amazon.com/blogs/developer/aws-sdk-for-go-aligns-with-go-release-policy-on-supported-runtimes/).
* **Dependency Update**: Updated to the latest SDK module versions

# v1.40.2 (2023-10-12)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.40.1 (2023-10-06)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.40.0 (2023-09-26)

* **Feature**: This release adds a new field COMPLETED to the ReplicationStatus Enum. You can now use this field to validate the replication status of S3 objects using the AWS SDK.

# v1.39.0 (2023-09-20)

* **Feature**: Fix an issue where the SDK can fail to unmarshall response due to NumberFormatException

# v1.38.5 (2023-08-21)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.38.4 (2023-08-18)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.38.3 (2023-08-17)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.38.2 (2023-08-07)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.38.1 (2023-08-01)

* No change notes available for this release.

# v1.38.0 (2023-07-31)

* **Feature**: Adds support for smithy-modeled endpoint resolution. A new rules-based endpoint resolution will be added to the SDK which will supercede and deprecate existing endpoint resolution. Specifically, EndpointResolver will be deprecated while BaseEndpoint and EndpointResolverV2 will take its place. For more information, please see the Endpoints section in our Developer Guide.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.37.1 (2023-07-28)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.37.0 (2023-07-13)

* **Feature**: S3 Inventory now supports Object Access Control List and Object Owner as available object metadata fields in inventory reports.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.36.0 (2023-06-28)

* **Feature**: The S3 LISTObjects, ListObjectsV2 and ListObjectVersions API now supports a new optional header x-amz-optional-object-attributes. If header contains RestoreStatus as the value, then S3 will include Glacier restore status i.e. isRestoreInProgress and RestoreExpiryDate in List response.

# v1.35.0 (2023-06-16)

* **Feature**: This release adds SDK support for request-payer request header and request-charged response header in the "GetBucketAccelerateConfiguration", "ListMultipartUploads", "ListObjects", "ListObjectsV2" and "ListObjectVersions" S3 APIs.

# v1.34.1 (2023-06-15)

* No change notes available for this release.

# v1.34.0 (2023-06-13)

* **Feature**: Integrate double encryption feature to SDKs.
* **Bug Fix**: Fix HeadObject to return types.Nound when an object does not exist. Fixes [2084](https://github.com/aws/aws-sdk-go-v2/issues/2084)
* **Dependency Update**: Updated to the latest SDK module versions

# v1.33.1 (2023-05-04)

* **Documentation**: Documentation updates for Amazon S3

# v1.33.0 (2023-04-24)

* **Feature**: added custom paginators for listMultipartUploads and ListObjectVersions
* **Dependency Update**: Updated to the latest SDK module versions

# v1.32.0 (2023-04-19)

* **Feature**: Provides support for "Snow" Storage class.

# v1.31.3 (2023-04-10)

* No change notes available for this release.

# v1.31.2 (2023-04-07)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.31.1 (2023-03-31)

* **Documentation**: Documentation updates for Amazon S3

# v1.31.0 (2023-03-21)

* **Feature**: port v1 sdk 100-continue http header customization for s3 PutObject/UploadPart request and enable user config
* **Dependency Update**: Updated to the latest SDK module versions

# v1.30.6 (2023-03-10)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.30.5 (2023-02-22)

* **Bug Fix**: Prevent nil pointer dereference when retrieving error codes.

# v1.30.4 (2023-02-20)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.30.3 (2023-02-14)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.30.2 (2023-02-03)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.30.1 (2023-01-23)

* No change notes available for this release.

# v1.30.0 (2023-01-05)

* **Feature**: Add `ErrorCodeOverride` field to all error structs (aws/smithy-go#401).

# v1.29.6 (2022-12-15)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.29.5 (2022-12-02)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.29.4 (2022-11-22)

* No change notes available for this release.

# v1.29.3 (2022-11-16)

* No change notes available for this release.

# v1.29.2 (2022-11-10)

* No change notes available for this release.

# v1.29.1 (2022-10-24)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.29.0 (2022-10-21)

* **Feature**: S3 on Outposts launches support for automatic bucket-style alias. You can use the automatic access point alias instead of an access point ARN for any object-level operation in an Outposts bucket.
* **Bug Fix**: The SDK client has been updated to utilize the `aws.IsCredentialsProvider` function for determining if `aws.AnonymousCredentials` has been configured for the `CredentialProvider`.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.28.0 (2022-10-19)

* **Feature**: Updates internal logic for constructing API endpoints. We have added rule-based endpoints and internal model parameters.

# v1.27.11 (2022-09-20)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.10 (2022-09-14)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.9 (2022-09-02)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.8 (2022-08-31)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.7 (2022-08-30)

* No change notes available for this release.

# v1.27.6 (2022-08-29)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.5 (2022-08-11)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.4 (2022-08-09)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.3 (2022-08-08)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.2 (2022-08-01)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.1 (2022-07-05)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.27.0 (2022-07-01)

* **Feature**: Add presign support for HeadBucket, DeleteObject, and DeleteBucket. Fixes [#1076](https://github.com/aws/aws-sdk-go-v2/issues/1076).

# v1.26.12 (2022-06-29)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.11 (2022-06-07)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.10 (2022-05-17)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.9 (2022-05-06)

* No change notes available for this release.

# v1.26.8 (2022-05-03)

* **Documentation**: Documentation only update for doc bug fixes for the S3 API docs.

# v1.26.7 (2022-04-27)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.6 (2022-04-25)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.5 (2022-04-12)

* **Bug Fix**: Fixes an issue that caused the unexported constructor function names for EventStream types to be swapped for the event reader and writer respectivly.

# v1.26.4 (2022-04-07)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.3 (2022-03-30)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.2 (2022-03-24)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.1 (2022-03-23)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.26.0 (2022-03-08)

* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Dependency Update**: Updated to the latest SDK module versions

# v1.25.0 (2022-02-24)

* **Feature**: API client updated
* **Feature**: Adds RetryMaxAttempts and RetryMod to API client Options. This allows the API clients' default Retryer to be configured from the shared configuration files or environment variables. Adding a new Retry mode of `Adaptive`. `Adaptive` retry mode is an experimental mode, adding client rate limiting when throttles reponses are received from an API. See [retry.AdaptiveMode](https://pkg.go.dev/github.com/aws/aws-sdk-go-v2/aws/retry#AdaptiveMode) for more details, and configuration options.
* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Bug Fix**: Fixes the AWS Sigv4 signer to trim header value's whitespace when computing the canonical headers block of the string to sign.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.24.1 (2022-01-28)

* **Bug Fix**: Updates SDK API client deserialization to pre-allocate byte slice and string response payloads, [#1565](https://github.com/aws/aws-sdk-go-v2/pull/1565). Thanks to [Tyson Mote](https://github.com/tysonmote) for submitting this PR.

# v1.24.0 (2022-01-14)

* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Dependency Update**: Updated to the latest SDK module versions

# v1.23.0 (2022-01-07)

* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Documentation**: API client updated
* **Dependency Update**: Updated to the latest SDK module versions

# v1.22.0 (2021-12-21)

* **Feature**: API Paginators now support specifying the initial starting token, and support stopping on empty string tokens.
* **Feature**: Updated to latest service endpoints

# v1.21.0 (2021-12-02)

* **Feature**: API client updated
* **Bug Fix**: Fixes a bug that prevented aws.EndpointResolverWithOptions from being used by the service client. ([#1514](https://github.com/aws/aws-sdk-go-v2/pull/1514))
* **Dependency Update**: Updated to the latest SDK module versions

# v1.20.0 (2021-11-30)

* **Feature**: API client updated

# v1.19.1 (2021-11-19)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.19.0 (2021-11-12)

* **Feature**: Waiters now have a `WaitForOutput` method, which can be used to retrieve the output of the successful wait operation. Thank you to [Andrew Haines](https://github.com/haines) for contributing this feature.

# v1.18.0 (2021-11-06)

* **Feature**: Support has been added for the SelectObjectContent API.
* **Feature**: The SDK now supports configuration of FIPS and DualStack endpoints using environment variables, shared configuration, or programmatically.
* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Feature**: Updated service to latest API model.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.17.0 (2021-10-21)

* **Feature**: Updated  to latest version
* **Feature**: Updates S3 streaming operations - PutObject, UploadPart, WriteGetObjectResponse to use unsigned payload signing auth when TLS is enabled.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.16.1 (2021-10-11)

* **Dependency Update**: Updated to the latest SDK module versions

# v1.16.0 (2021-09-17)

* **Feature**: Updated API client and endpoints to latest revision.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.15.1 (2021-09-10)

* No change notes available for this release.

# v1.15.0 (2021-09-02)

* **Feature**: API client updated
* **Feature**: Add support for S3 Multi-Region Access Point ARNs.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.14.0 (2021-08-27)

* **Feature**: Updated API model to latest revision.
* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Dependency Update**: Updated to the latest SDK module versions

# v1.13.0 (2021-08-19)

* **Feature**: API client updated
* **Dependency Update**: Updated to the latest SDK module versions

# v1.12.0 (2021-08-04)

* **Feature**: Add `HeadObject` presign support. ([#1346](https://github.com/aws/aws-sdk-go-v2/pull/1346))
* **Dependency Update**: Updated `github.com/aws/smithy-go` to latest version.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.11.1 (2021-07-15)

* **Dependency Update**: Updated `github.com/aws/smithy-go` to latest version
* **Dependency Update**: Updated to the latest SDK module versions

# v1.11.0 (2021-06-25)

* **Feature**: Updated `github.com/aws/smithy-go` to latest version
* **Dependency Update**: Updated to the latest SDK module versions

# v1.10.0 (2021-06-04)

* **Feature**: The handling of AccessPoint and Outpost ARNs have been updated.
* **Feature**: Updated service client to latest API model.
* **Dependency Update**: Updated to the latest SDK module versions

# v1.9.0 (2021-05-25)

* **Feature**: API client updated

# v1.8.0 (2021-05-20)

* **Feature**: API client updated
* **Dependency Update**: Updated to the latest SDK module versions

# v1.7.0 (2021-05-14)

* **Feature**: Constant has been added to modules to enable runtime version inspection for reporting.
* **Feature**: Updated to latest service API model.
* **Dependency Update**: Updated to the latest SDK module versions

