// Code generated by go-swagger; DO NOT EDIT.

package iam_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIamServiceSearchPrincipalsParams creates a new IamServiceSearchPrincipalsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIamServiceSearchPrincipalsParams() *IamServiceSearchPrincipalsParams {
	return &IamServiceSearchPrincipalsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIamServiceSearchPrincipalsParamsWithTimeout creates a new IamServiceSearchPrincipalsParams object
// with the ability to set a timeout on a request.
func NewIamServiceSearchPrincipalsParamsWithTimeout(timeout time.Duration) *IamServiceSearchPrincipalsParams {
	return &IamServiceSearchPrincipalsParams{
		timeout: timeout,
	}
}

// NewIamServiceSearchPrincipalsParamsWithContext creates a new IamServiceSearchPrincipalsParams object
// with the ability to set a context for a request.
func NewIamServiceSearchPrincipalsParamsWithContext(ctx context.Context) *IamServiceSearchPrincipalsParams {
	return &IamServiceSearchPrincipalsParams{
		Context: ctx,
	}
}

// NewIamServiceSearchPrincipalsParamsWithHTTPClient creates a new IamServiceSearchPrincipalsParams object
// with the ability to set a custom HTTPClient for a request.
func NewIamServiceSearchPrincipalsParamsWithHTTPClient(client *http.Client) *IamServiceSearchPrincipalsParams {
	return &IamServiceSearchPrincipalsParams{
		HTTPClient: client,
	}
}

/*
IamServiceSearchPrincipalsParams contains all the parameters to send to the API endpoint

	for the iam service search principals operation.

	Typically these are written to a http.Request.
*/
type IamServiceSearchPrincipalsParams struct {

	// Body.
	Body IamServiceSearchPrincipalsBody

	/* OrganizationID.

	     organization_id is the ID of the organization in which the principals
	belong.
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the iam service search principals params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IamServiceSearchPrincipalsParams) WithDefaults() *IamServiceSearchPrincipalsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the iam service search principals params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IamServiceSearchPrincipalsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) WithTimeout(timeout time.Duration) *IamServiceSearchPrincipalsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) WithContext(ctx context.Context) *IamServiceSearchPrincipalsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) WithHTTPClient(client *http.Client) *IamServiceSearchPrincipalsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) WithBody(body IamServiceSearchPrincipalsBody) *IamServiceSearchPrincipalsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) SetBody(body IamServiceSearchPrincipalsBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) WithOrganizationID(organizationID string) *IamServiceSearchPrincipalsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the iam service search principals params
func (o *IamServiceSearchPrincipalsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *IamServiceSearchPrincipalsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
