// Code generated by go-swagger; DO NOT EDIT.

package project_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewProjectServiceSetDescriptionParams creates a new ProjectServiceSetDescriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewProjectServiceSetDescriptionParams() *ProjectServiceSetDescriptionParams {
	return &ProjectServiceSetDescriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewProjectServiceSetDescriptionParamsWithTimeout creates a new ProjectServiceSetDescriptionParams object
// with the ability to set a timeout on a request.
func NewProjectServiceSetDescriptionParamsWithTimeout(timeout time.Duration) *ProjectServiceSetDescriptionParams {
	return &ProjectServiceSetDescriptionParams{
		timeout: timeout,
	}
}

// NewProjectServiceSetDescriptionParamsWithContext creates a new ProjectServiceSetDescriptionParams object
// with the ability to set a context for a request.
func NewProjectServiceSetDescriptionParamsWithContext(ctx context.Context) *ProjectServiceSetDescriptionParams {
	return &ProjectServiceSetDescriptionParams{
		Context: ctx,
	}
}

// NewProjectServiceSetDescriptionParamsWithHTTPClient creates a new ProjectServiceSetDescriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewProjectServiceSetDescriptionParamsWithHTTPClient(client *http.Client) *ProjectServiceSetDescriptionParams {
	return &ProjectServiceSetDescriptionParams{
		HTTPClient: client,
	}
}

/*
ProjectServiceSetDescriptionParams contains all the parameters to send to the API endpoint

	for the project service set description operation.

	Typically these are written to a http.Request.
*/
type ProjectServiceSetDescriptionParams struct {

	// Body.
	Body ProjectServiceSetDescriptionBody

	/* ID.

	   id is the identifier of the project to update.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the project service set description params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ProjectServiceSetDescriptionParams) WithDefaults() *ProjectServiceSetDescriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the project service set description params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ProjectServiceSetDescriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the project service set description params
func (o *ProjectServiceSetDescriptionParams) WithTimeout(timeout time.Duration) *ProjectServiceSetDescriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the project service set description params
func (o *ProjectServiceSetDescriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the project service set description params
func (o *ProjectServiceSetDescriptionParams) WithContext(ctx context.Context) *ProjectServiceSetDescriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the project service set description params
func (o *ProjectServiceSetDescriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the project service set description params
func (o *ProjectServiceSetDescriptionParams) WithHTTPClient(client *http.Client) *ProjectServiceSetDescriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the project service set description params
func (o *ProjectServiceSetDescriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the project service set description params
func (o *ProjectServiceSetDescriptionParams) WithBody(body ProjectServiceSetDescriptionBody) *ProjectServiceSetDescriptionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the project service set description params
func (o *ProjectServiceSetDescriptionParams) SetBody(body ProjectServiceSetDescriptionBody) {
	o.Body = body
}

// WithID adds the id to the project service set description params
func (o *ProjectServiceSetDescriptionParams) WithID(id string) *ProjectServiceSetDescriptionParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the project service set description params
func (o *ProjectServiceSetDescriptionParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ProjectServiceSetDescriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
