/*
* Copyright 2018 - Present Okta, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
 */

// Code generated by okta openapi generator. DO NOT EDIT.

package okta

import "encoding/json"

type AuthenticatorSettings struct {
	AllowedFor                string          `json:"allowedFor,omitempty"`
	AppInstanceId             string          `json:"appInstanceId,omitempty"`
	ChannelBinding            *ChannelBinding `json:"channelBinding,omitempty"`
	Compliance                *Compliance     `json:"compliance,omitempty"`
	TokenLifetimeInMinutes    int64           `json:"-"`
	TokenLifetimeInMinutesPtr *int64          `json:"tokenLifetimeInMinutes,omitempty"`
	UserVerification          string          `json:"userVerification,omitempty"`
}

func (a *AuthenticatorSettings) MarshalJSON() ([]byte, error) {
	type Alias AuthenticatorSettings
	type local struct {
		*Alias
	}
	result := local{Alias: (*Alias)(a)}
	if a.TokenLifetimeInMinutes != 0 {
		result.TokenLifetimeInMinutesPtr = Int64Ptr(a.TokenLifetimeInMinutes)
	}
	return json.Marshal(&result)
}

func (a *AuthenticatorSettings) UnmarshalJSON(data []byte) error {
	type Alias AuthenticatorSettings

	result := &struct {
		*Alias
	}{
		Alias: (*Alias)(a),
	}
	if err := json.Unmarshal(data, &result); err != nil {
		return err
	}
	if result.TokenLifetimeInMinutesPtr != nil {
		a.TokenLifetimeInMinutes = *result.TokenLifetimeInMinutesPtr
		a.TokenLifetimeInMinutesPtr = result.TokenLifetimeInMinutesPtr
	}
	return nil
}
