/*
* Copyright 2018 - Present Okta, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
 */

// Code generated by okta openapi generator. DO NOT EDIT.

package okta

import "encoding/json"

type IdentityProviderCredentialsTrust struct {
	Audience                   string `json:"audience,omitempty"`
	Issuer                     string `json:"issuer,omitempty"`
	Kid                        string `json:"kid,omitempty"`
	Revocation                 string `json:"revocation,omitempty"`
	RevocationCacheLifetime    int64  `json:"-"`
	RevocationCacheLifetimePtr *int64 `json:"revocationCacheLifetime,omitempty"`
}

func (a *IdentityProviderCredentialsTrust) MarshalJSON() ([]byte, error) {
	type Alias IdentityProviderCredentialsTrust
	type local struct {
		*Alias
	}
	result := local{Alias: (*Alias)(a)}
	if a.RevocationCacheLifetime != 0 {
		result.RevocationCacheLifetimePtr = Int64Ptr(a.RevocationCacheLifetime)
	}
	return json.Marshal(&result)
}

func (a *IdentityProviderCredentialsTrust) UnmarshalJSON(data []byte) error {
	type Alias IdentityProviderCredentialsTrust

	result := &struct {
		*Alias
	}{
		Alias: (*Alias)(a),
	}
	if err := json.Unmarshal(data, &result); err != nil {
		return err
	}
	if result.RevocationCacheLifetimePtr != nil {
		a.RevocationCacheLifetime = *result.RevocationCacheLifetimePtr
		a.RevocationCacheLifetimePtr = result.RevocationCacheLifetimePtr
	}
	return nil
}
