/*
* Copyright 2018 - Present Okta, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
 */

// Code generated by okta openapi generator. DO NOT EDIT.

package okta

import "encoding/json"

type OktaSignOnPolicyRuleSignonActions struct {
	Access                  string                                    `json:"access,omitempty"`
	FactorLifetime          int64                                     `json:"-"`
	FactorLifetimePtr       *int64                                    `json:"factorLifetime,omitempty"`
	FactorPromptMode        string                                    `json:"factorPromptMode,omitempty"`
	RememberDeviceByDefault *bool                                     `json:"rememberDeviceByDefault,omitempty"`
	RequireFactor           *bool                                     `json:"requireFactor,omitempty"`
	Session                 *OktaSignOnPolicyRuleSignonSessionActions `json:"session,omitempty"`
}

func NewOktaSignOnPolicyRuleSignonActions() *OktaSignOnPolicyRuleSignonActions {
	return &OktaSignOnPolicyRuleSignonActions{
		RememberDeviceByDefault: boolPtr(false),
		RequireFactor:           boolPtr(false),
	}
}

func (a *OktaSignOnPolicyRuleSignonActions) IsPolicyInstance() bool {
	return true
}

func (a *OktaSignOnPolicyRuleSignonActions) MarshalJSON() ([]byte, error) {
	type Alias OktaSignOnPolicyRuleSignonActions
	type local struct {
		*Alias
	}
	result := local{Alias: (*Alias)(a)}
	if a.FactorLifetime != 0 {
		result.FactorLifetimePtr = Int64Ptr(a.FactorLifetime)
	}
	return json.Marshal(&result)
}

func (a *OktaSignOnPolicyRuleSignonActions) UnmarshalJSON(data []byte) error {
	type Alias OktaSignOnPolicyRuleSignonActions

	result := &struct {
		*Alias
	}{
		Alias: (*Alias)(a),
	}
	if err := json.Unmarshal(data, &result); err != nil {
		return err
	}
	if result.FactorLifetimePtr != nil {
		a.FactorLifetime = *result.FactorLifetimePtr
		a.FactorLifetimePtr = result.FactorLifetimePtr
	}
	return nil
}
