/*
* Copyright 2018 - Present Okta, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
 */

// Code generated by okta openapi generator. DO NOT EDIT.

package okta

import "encoding/json"

type TokenAuthorizationServerPolicyRuleAction struct {
	AccessTokenLifetimeMinutes     int64                                               `json:"-"`
	AccessTokenLifetimeMinutesPtr  *int64                                              `json:"accessTokenLifetimeMinutes"`
	InlineHook                     *TokenAuthorizationServerPolicyRuleActionInlineHook `json:"inlineHook,omitempty"`
	RefreshTokenLifetimeMinutes    int64                                               `json:"-"`
	RefreshTokenLifetimeMinutesPtr *int64                                              `json:"refreshTokenLifetimeMinutes"`
	RefreshTokenWindowMinutes      int64                                               `json:"-"`
	RefreshTokenWindowMinutesPtr   *int64                                              `json:"refreshTokenWindowMinutes"`
}

func (a *TokenAuthorizationServerPolicyRuleAction) MarshalJSON() ([]byte, error) {
	type Alias TokenAuthorizationServerPolicyRuleAction
	type local struct {
		*Alias
	}
	result := local{Alias: (*Alias)(a)}
	if a.AccessTokenLifetimeMinutes != 0 {
		result.AccessTokenLifetimeMinutesPtr = Int64Ptr(a.AccessTokenLifetimeMinutes)
	}
	if a.RefreshTokenLifetimeMinutes != 0 {
		result.RefreshTokenLifetimeMinutesPtr = Int64Ptr(a.RefreshTokenLifetimeMinutes)
	}
	if a.RefreshTokenWindowMinutes != 0 {
		result.RefreshTokenWindowMinutesPtr = Int64Ptr(a.RefreshTokenWindowMinutes)
	}
	return json.Marshal(&result)
}

func (a *TokenAuthorizationServerPolicyRuleAction) UnmarshalJSON(data []byte) error {
	type Alias TokenAuthorizationServerPolicyRuleAction

	result := &struct {
		*Alias
	}{
		Alias: (*Alias)(a),
	}
	if err := json.Unmarshal(data, &result); err != nil {
		return err
	}
	if result.AccessTokenLifetimeMinutesPtr != nil {
		a.AccessTokenLifetimeMinutes = *result.AccessTokenLifetimeMinutesPtr
		a.AccessTokenLifetimeMinutesPtr = result.AccessTokenLifetimeMinutesPtr
	}
	if result.RefreshTokenLifetimeMinutesPtr != nil {
		a.RefreshTokenLifetimeMinutes = *result.RefreshTokenLifetimeMinutesPtr
		a.RefreshTokenLifetimeMinutesPtr = result.RefreshTokenLifetimeMinutesPtr
	}
	if result.RefreshTokenWindowMinutesPtr != nil {
		a.RefreshTokenWindowMinutes = *result.RefreshTokenWindowMinutesPtr
		a.RefreshTokenWindowMinutesPtr = result.RefreshTokenWindowMinutesPtr
	}
	return nil
}
